

from scipy import *
from pylab import *


C1 = 1/6.0
C2 = 1/12.0
Dt = 0.3


def diffuse(p, c1=C1, c2=C2, dt=Dt):
    p[1:-1,1:-1] =  (1-dt)*p[1:-1,1:-1] + dt*(c1*(p[0:-2,1:-1] + p[2:,1:-1] + p[1:-1,0:-2] + p [1:-1,2:]) + c2*(p[0:-2,0:-2] + p[2:,2:] + p[0:-2,2:] + p[2:,0:-2]))
    return


nx = 128
ny = 128
dims = (nx,ny)


T = zeros(dims,dtype=float)
x,y = mgrid[0:nx,0:ny]
rsq_array = (x-nx/2)**2+(y-nx/2)**2


T[nx/2,ny/2] = 1
rsq = [0]
time = [0]


ion()
figure(0)
for k in range(500):
    diffuse(T)
    rsq.append(sum(rsq_array*T))
    time.append(k*Dt)

    if (k%10 == 0): 
        imshow(T)
        draw()
figure(1)
plot(time,rsq)

show()
pause(10)
