from scipy import *
from pylab import *
import time


def randdir():
    n = randint(4)
    return dir[n]


def randcircle(radius = 10.0):
    while 1:
        r = 2*(random(2) - array((0.5,0.5)))
        rsq = sum(r*r)
        if rsq < 1:
            return radius*r/sqrt(rsq)

def int_randcircle(radius): 
    return int_(randcircle(radius))

dir = array([ [1,0], [-1,0], [0,1], [0,-1]])

Seed = 10000
seed(Seed)


n=128
dim = (n,n)
p = zeros(dim)
center = (n/2,n/2)
p[center] = 1

r_max = 5
r_max_sq = 4*r_max**2

stick_prob = 1.0

ion()
pad = 5

for i in range(1000000):
    next_to = False
    if i%100 == 0:
        imshow(p,interpolation="nearest")
        show()
        draw()
	print i
#	show()
	time.sleep(0.1)

    r = int_randcircle(r_max)
    if r_max > n/4:
        break 
    while True:
        r_old = r
        r += randdir()
        rsq = r[0]**2+r[1]**2
        if  rsq > r_max_sq:
             break
        for j in range(4):
            neighbor = center + r + dir[j]
            if p[tuple(neighbor)] > 0:
                next_to = True
                break
        if next_to:
            next_to = False
            if random() < stick_prob:
                p[tuple(center + r)] = sqrt(i)
                
                r_abs = sqrt(rsq)
                if r_abs + pad > r_max:
                    r_max = r_abs + pad
                    r_max_sq = 4*r_max**2
                break
            else:
                r = r_old


print "done"
pause(100)
show()
